package addressbook;

import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

/**
 * ϿץꥱǡŪ˻Ȥؿ饹
 */
public class AddressbookUtils {

		/**
		 * JAXP DocumentBuilderƤӽФ
		 * @return DocumentBuilder
		 */
		public static DocumentBuilder getDocumentBuilder() {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			dbf.setValidating(false);
			dbf.setIgnoringElementContentWhitespace(true);
			DocumentBuilder db;
			try {
				return dbf.newDocumentBuilder();
			} catch (Exception e) {
				e.printStackTrace();
			}
			return null;
		}

		/**
		 * ʸ󤫤DOM Document
		 * @param xmlData XMLʸ
		 * @return DOM Document
		 */
		public static Document loadXMLFromString(String xmlData) {
			DocumentBuilder db = getDocumentBuilder();
			try {
				return db.parse(new InputSource(new StringReader(xmlData)));
			} catch (Exception e) {
				e.printStackTrace();
				return null;
			}
		}
		
		/**
		 * ꤷ̾ĻҥΡɤ֤
		 * @param parents Node
		 * @param tagName String
		 * @return
		 */
	    public static Node getChildNodeByTagName(Node parents, String tagName) {
			Node child = null;
			NodeList childlen = parents.getChildNodes();
			//ҥΡɤο
			int len = (childlen != null) ? childlen.getLength() : 0;
			for (int i = 0; i < len; i++) {
				Node tmpchild = childlen.item(i);
				// ̾tagNameƱǤФΥΡɤ֤
				if (tmpchild.getNodeName().equals(tagName)) {
					child = tmpchild;
					break;
				}
			}
			return child;	
		}

		/**
		 * ̤Query-ResultsǤͤͤȤƼФ
		 */
		public static int getQResultInteger(Document doc){
			/*
			 * ̤Ȥ 
			 * <?xml version="1.0" encoding="UTF-8" ?>
			 * <Query-Results>
			 * 100
			 * </Query-Results>
			 * Ȥ(\n)äʸ֤äƤΤǡ
			 * Query-ResultsǤͤ\nͤ
			 */
			Element element = (Element) doc.getElementsByTagName("Query-Results")
					.item(0);
			String nodevalue = element.getFirstChild().getNodeValue().replace("\n",	"");
			// ʸ󤫤ͤ˥㥹Ȥ ʸξ0֤
			if(nodevalue.equals("")){
				return 0;
			}else{
				return Integer.parseInt(nodevalue);
			}	
		}
	    
}